// Copyright 2020 Tokamak contributors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

public struct TextEditor: View {
  let textBinding: Binding<String>

  public init(text: Binding<String>) {
    textBinding = text
  }

  public var body: Never {
    neverBody("TextEditor")
  }
}

public struct _TextEditorProxy {
  public let subject: TextEditor

  public init(_ subject: TextEditor) { self.subject = subject }

  public var textBinding: Binding<String> { subject.textBinding }
}
